/* Worst Case Scenario */
BEGIN TRAN
	SELECT @balance = balance from checking 
	Check with - debit
	Then update
COMMIT 

/* No data Integrity Issues but not the best performing! */
BEGIN TRAN
	update checking (allow debit)
	select @balance = balance from checking 
	IF @balance >= 0
		COMMIT
	 
/* The best option! */
BEGIN TRAN
UPDATE checking 
	SET @balance = balance = balance - @debit
IF @balance >= 0
	COMMIT
ELSE
BEGIN
-- 	do all the other banking stuff
-- 	Over Draft Protection Checking
-- 	Visa for Charges
	ELSE
	ROLLBACK
END